/*
 * Red Hat retrieval tool.
 *
 * (C) 1999 Alan Cox.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version
 * 2 of the License, or (at your option) any later version.
 */
 
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <fcntl.h> 
#include <errno.h>
#include <sys/time.h>

#include "config.h"
#include "engine.h"

int main(int argc, char *argv[])
{
	int s;
	int head=1;
	int trip=0;
	
	char *p;
		
	s=host_connect("www.redhat.com",80);
	if(s==-1)
		return 1;
	
	host_get(s, "www.redhat.com", "/");
	
	while((p=host_readline(s))!=NULL)
	{
		if(head && *p!=0 && *p!='\r')
			continue;
		
		if(head)
		{
			head = 0;
			continue;
		}
		if(trip==0 && strstr(p, "<!-- The Buzz"))
		{
			trip++;
			continue;
		}
		if(trip==1)
		{
			trip++;
			continue;
		}
		if(trip!=2)
			continue;
		if(strstr(p, "</TR>"))
			break;
		printf("%s\n",p);
	}
}
	